/*
# X-BASED HEXTRIS
#
#  Hextris.h
#
###
#
#  Copyright (c) 1993 - 2006	David Albert Bagley, bagleyd@tux.org
#
#                   All Rights Reserved
#
#  Permission to use, copy, modify, and distribute this software and
#  its documentation for any purpose and without fee is hereby granted,
#  provided that the above copyright notice appear in all copies and
#  that both that copyright notice and this permission notice appear in
#  supporting documentation, and that the name of the author not be
#  used in advertising or publicity pertaining to distribution of the
#  software without specific, written prior permission.
#
#  This program is distributed in the hope that it will be "playable",
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
*/

/* Public header file for Hextris */

#ifndef _XtHextris_h
#define _XtHextris_h

/***********************************************************************
 *
 * Hextris Widget
 *
 ***********************************************************************/

#ifndef WINVER
#define XtNmono ((char *) "mono")
#define XtNreverse ((char *) "reverse")
#define XtNframeColor ((char *) "frameColor")
#define XtNdelay ((char *) "delay")
#define XtNsound ((char *) "sound")
#define XtNbumpSound ((char *) "bumpSound")
#define XtNlevel ((char *) "level")
#define XtNcolumns ((char *) "columns")
#define XtNunits ((char *) "units")
#define XtNfill ((char *) "fill")
#define XtNfixedFill ((char *) "fixedFill")
#define XtNsuddenAppear ((char *) "suddenAppear")
#define XtNcorners ((char *) "corners")
#define XtNmixed ((char *) "mixed")
#define XtNbonus ((char *) "bonus")
#define XtNplainPiece ((char *) "plainPiece")
#define XtNcw ((char *) "cw")
#define XtNshowNext ((char *) "showNext")
#define XtNgrid ((char *) "grid")
#define XtNscore ((char *) "score")
#define XtNcompletedRows ((char *) "completedRows")
#define XtNuserName ((char *) "userName")
#define XtNscoreFile ((char *) "scoreFile")
#define XtNscoreOnly ((char *) "scoreOnly")
#define XtNversionOnly ((char *) "versionOnly")
#define XtNmenu ((char *) "menu")
#define XtNstart ((char *) "start")
#define XtNact ((char *) "act")
#define XtNrandomNumber ((char *) "randomNumber")
#define XtNrandomRotation ((char *) "randomRotation")
#define XtNrandomReflection ((char *) "randomReflection")
#define XtNselectCallback ((char *) "selectCallback")
#define XtCMono ((char *) "Mono")
#define XtCReverse ((char *) "Reverse")
#define XtCDelay ((char *) "Delay")
#define XtCSound ((char *) "Sound")
#define XtCBumpSound ((char *) "BumpSound")
#define XtCLevel ((char *) "Level")
#define XtCUnits ((char *) "Units")
#define XtCColumns ((char *) "Columns")
#define XtCFill ((char *) "Fill")
#define XtCFixedFill ((char *) "FixedFill")
#define XtCSuddenAppear ((char *) "SuddenAppear")
#define XtCCorners ((char *) "Corners")
#define XtCMixed ((char *) "Mixed")
#define XtCBonus ((char *) "Bonus")
#define XtCPlainPiece ((char *) "PlainPiece")
#define XtCCw ((char *) "Cw")
#define XtCShowNext ((char *) "ShowNext")
#define XtCGrid ((char *) "Grid")
#define XtCLevel ((char *) "Level")
#define XtCScore ((char *) "Score")
#define XtCCompletedRows ((char *) "CompletedRows")
#define XtCUserName ((char *) "UserName")
#define XtCScoreFile ((char *) "ScoreFile")
#define XtCMenu ((char *) "Menu")
#define XtCAct ((char *) "Act")
#define XtCRandomNumber ((char *) "RandomNumber")
#define XtCRandomRotation ((char *) "RandomRotation")
#define XtCRandomReflection ((char *) "RandomReflection")

typedef struct _HextrisClassRec *HextrisWidgetClass;

extern WidgetClass hextrisWidgetClass;

typedef struct {
        XEvent     *event;
        int         reason;
	int         randomNumber, randomRotation, randomReflection;
	Boolean     newBonus;
	int         units;
	Boolean     corners, mixed;
} hextrisCallbackStruct;
#endif

#define GAME_HIDE (-7)
#define GAME_RESTART_QUERY (-6)
#define GAME_STATUS (-5)
#define GAME_GAMEOVER (-4)
#define GAME_CLEARNEXT (-3)
#define GAME_STARTED (-2)
#define GAME_IGNORE (-1)
#define GAME_DRAWNEXT 1
#define GAME_DECUNITS 2
#define GAME_INCUNITS 3
#define GAME_DECCOLUMNS 4
#define GAME_INCCOLUMNS 5
#define GAME_FIXEDFILL 6
#define GAME_SUDDENAPPEAR 7
#define GAME_CORNERS 8
#define GAME_MIXED 9
#define GAME_BONUS 10
#define GAME_CW 11
#define GAME_PLAINPIECE 12
#define GAME_SHOWNEXT 13
#define GAME_GRID 14
#define GAME_SOUND 15
#define GAME_FILL0 20
#define GAME_FILL1 21
#define GAME_FILL2 22
#define GAME_FILL3 23
#define GAME_FILL4 24
#define GAME_FILL5 25
#define GAME_FILL6 26
#define GAME_FILL7 27
#define GAME_FILL8 28
#define GAME_FILL9 29
#define GAME_FILL10 30

#define MIN_LEVELS 1
#define MAX_LEVELS 20
#define DEFAULTLEVELS 3
#define MIN_UNITS       2 /* Why not 1 you say? */
#define MAX_UNITS       5
#define DEFAULTUNITS	4
#define MIN_COLUMNS	MAX_UNITS
#define MAX_COLUMNS	30
#define DEFAULTCOLUMNS	10
#define MIN_CORNERS	MIN_UNITS
#define MAX_CORNERS	4
#define DEFAULTCORNERS	FALSE
#define DEFAULTMIXED	FALSE

#ifdef MONOTEST
#define DEFAULTMONO TRUE
#else
#define DEFAULTMONO FALSE
#endif
#define DEFAULTREVERSE FALSE

#define LEGAL(n,g,m,b)  (((n)>=MIN_UNITS+(m))&&\
			((n)<=((g)?MAX_CORNERS:MAX_UNITS)-(b)))

typedef struct _HextrisRec *HextrisWidget;

#endif /* _XtHextris_h */
/* DON'T ADD STUFF AFTER THIS #endif */
