/*
# X-BASED WELLTRIS
#
#  WelltrisNP.h
#
###
#
#  Copyright (c) 1994 - 2006	David Albert Bagley, bagleyd@tux.org
#
#                   All Rights Reserved
#
#  Permission to use, copy, modify, and distribute this software and
#  its documentation for any purpose and without fee is hereby granted,
#  provided that the above copyright notice appear in all copies and
#  that both that copyright notice and this permission notice appear in
#  supporting documentation, and that the name of the author not be
#  used in advertising or publicity pertaining to distribution of the
#  software without specific, written prior permission.
#
#  This program is distributed in the hope that it will be "useful",
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
*/

/* Private header file for Next Welltris */

#ifndef _WelltrisNP_h
#define _WelltrisNP_h
#include "WelltrisP.h"
#include "WelltrisN.h"

#ifdef WINVER
extern void DestroyNextGame(HBRUSH brush);
extern void ResizeNextGame(NextWelltrisWidget w);
extern void InitializeNextGame(NextWelltrisWidget w, HBRUSH brush);
extern void ExposeNextGame(NextWelltrisWidget w);
extern void HideNextGame(NextWelltrisWidget w);
extern void ToggleNextGame(NextWelltrisWidget w);
extern void EnterNextGame(NextWelltrisWidget w);
extern void LeaveNextGame(NextWelltrisWidget w);
extern Boolean DiagonalNextGame(NextWelltrisWidget w);
extern void SoundNextGame(NextWelltrisWidget w);
extern Boolean MixedNextGame(NextWelltrisWidget w);
extern void ValueNextGame(NextWelltrisWidget w,
	int randomNumber, int randomRotation, int randomRefleection,
	int units, Boolean diagonal, Boolean mixed, Boolean newBonus);
extern void PauseNextGame(NextWelltrisWidget w);
extern void ShowNextNextGame(NextWelltrisWidget w);
extern void setNextGame(NextWelltrisWidget w, int reason);
#else

typedef struct _NextWelltrisPart
{
	int randomNumber, randomRotation, randomReflection;
	Boolean newBonus;
} NextWelltrisPart;
#endif

typedef struct _NextWelltrisRec
{
	CorePart core;
	WelltrisPart welltris;
#ifndef WINVER
	NextWelltrisPart nextWelltris;
#endif
} NextWelltrisRec;

#ifndef WINVER
/* This gets around C's inability to do inheritance */
typedef struct _NextWelltrisClassPart
{
	int ignore;
} NextWelltrisClassPart;

typedef struct _NextWelltrisClassRec
{
	CoreClassPart coreClass;
	WelltrisClassPart welltrisClass;
	NextWelltrisClassPart nextWelltrisClass;
} NextWelltrisClassRec;

extern NextWelltrisClassRec nextWelltrisClassRec;
#endif
#endif /* _WelltrisNP_h */
